/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : July, 1997                                                     */
/* File Name : Vector.h                                                  */
/*************************************************************************/
/*************************************************************************/

#include "Vector.h"

/*
//
*/

template<class T1>
Vector<T1>::Vector()
{      data = NULL;
   capacity = 0;
      index = 0;
  currentCapacity = 0;
}// end of default constructor

/*
//
*/

template<class T1>
Vector<T1>::Vector(unsigned _capacity)
{      data = new T1[_capacity];
   currentCapacity = capacity = _capacity;
      index = 0;
}// end of default constructor

/*
// Copy constructor
*/

template<class T1>
Vector<T1>::Vector(const  Vector<T1>& RHS)
{ copyFrom(RHS); }

/*
//
*/

template<class T1>
Vector<T1>::~Vector()
{
  delete [] data;
  currentCapacity = capacity = 0;
     index = 0;
  data = NULL;
}// end of Destructor

/*
// Adds the given object
*/

template<class T1>
void Vector<T1>::addElement(T1 _newElement)
{

   if(index<currentCapacity) 
   {  data[index] = _newElement;
      index++;
   }
   else
    {
      currentCapacity = index+5;

      T1 *temp = new T1[currentCapacity];

      for(unsigned i=0;i<index;i++) temp[i] = data[i];

      temp[i] = _newElement;

      if(index) delete [] data;

      index++;
      data = temp 

    }

}// end of addElement

/*
// Gets the pointer of indexed object.
// If we can not find it, then it will return
// NULL.
*/

template<class T1>
T1 *Vector<T1>::getElement(unsigned indx)
{
   T1 *ret = NULL;

   if(indx>=0 && indx<index) ret = new T1(data[indx]);

   return ret;

}// end of getElement()

/*
// Removes the given object from the Vector
*/

template<class T1>
Vector<T1>::removeElement(T1 removeItem)
{
   unsigned i = 0;
   int found = 0;
   int retCode = 0;

   while( !found && i<index)
   {
     if(data[i] == removeItem) retCode = removeElementAt(i);

     i++;

   }// end of while

   return retCode;

}//  end of removeElement()


/*
// Removes the given indexed object from the Vector
*/

template<class T1>
Vector<T1>::removeElementAt(unsigned index)
{
   int retCode = 0;

   if(indx>=0 && indx<index)
   {
     // Shift the elements left

     for(unsigned j=indx+1;j<index;j++) data[j-1] = data[j];
     
     // Decrement the current pointer

     index--;

     // Adjust the Capacity of the Vector occationally

     if((currentCapacity-index)>9 && index>capacity)
     {
	T1 *temp = new T1[index+5];

	for(unsigned i=0;i<index;i++) temp[i] = data[i];

	if(index) delete [] data;

	data = temp;

	currentCapacity = index+5;

     }// end of if

     retCode = 1;

   }// end of if

   return retCode;

}// end of removeElementAt()

/*
//
*/

template<class T1>
Vector<T1> Vector<T1>::operator=(const Vector<T1>& RHS)
{
   dispose();
   copyFrom(RHS);

}// end of operator=()

/*
// Compares two Vector Objects. Their index, capacity and
// each element should be equal. Equaliy test does not look
// this collection as a set.
*/

template<class T1>
Vector<T1>::operator==(const Vector<T1>& RHS)
{
   int ret = ( index == RHS.index ) && ( capacity == RHS.capacity ); 
   unsigned i = 0;

   ret = ret && ( currentCapacity == RHS.currentCapacity );

   while( ret && i<capacity )
   {  ret = ( data[i] == RHS.data[i] ); 
      i++;
   }// end of while

   return ret;

}// end of operator==()


/*
//
*/

template<class T1>
ostream & operator<<(ostream& os,const Vector<T1>& RHS)
{
   RHS.pritnMe(os);
   return os;

}// end of operator<<()

/*
//
*/

template<class T1>
void Vector<T1>::printMe(ostream&) const
{
  os << " Number of Elements : "<< index; << endl;
  for(unsigned i=0;i<index;i++) os << data[i] << " ";
  os << endl;

}// end of  printMe()

/*
//
*/

template<class T1>
unsigned Vector<T1>::getSize() const
{ return index; }

/*
//
*/

template<class T1>
void Vector<T1>::dispose() 
{
  if(index) delete [] data;
  index = 0;
  data  = NULL;
  if(capacity) data = new T1[capacity];
  currentCapacity = capacity;

}// end of dispose()

/*
//
*/

template<class T1>
void Vector<T1>::copyFrom(const Vector<T1>& RHS)
{
   capacity = RHS.capacity;
   currentCapacity = RHS.currentCapacity;
   index = RHS.index;

   data  = new T1[RHS.currentCapacity];

   for(unsigned i=0;i<index;i++) data[i] = RHS.data[i];

}// end of copyFrom() 




